#include <iostream>
#include <ltdl.h>
#include "foo.h"

int main( void) {
	try {
		if (lt_dlinit())
			throw "Unable to lt_dlinit";
		
		lt_dlhandle hndl = lt_dlopenext("./.libs/libbar.so");
		if (!hndl)
			throw "Unable to open ./.libs/libbar.so";

		Foo *(*fn)();
		(void *)fn = (void *)lt_dlsym( hndl, "_create");
		if (!fn)
			throw "Unable to find the symbol _create";

		Foo *foo = (*fn)();
		foo->hello();
		delete foo;

		lt_dlclose( hndl);
		lt_dlexit();
	} catch( const char *msg) {
		cerr << "Error: " << msg << " - " << lt_dlerror() << endl;
	}
	return 0;
}
